function r = getEHCMDir()
   % getEHCMDir Returns the path where the EHCMDemoFile.m is.
   % ------------------------------------------------------------------------
   % This file is part of the EHCM Toolbox v1
   %
   % The EHCM Toolbox - Energy Hub Component Modeling for Model Predictive Control.
   % Copyright (C) 2015  Automatic Control Laboratory, ETH Zurich.
   %
   % The EHCM Toolbox is free software; you can redistribute it and/or modify
   % it under the terms of the GNU General Public License as published by
   % the Free Software Foundation, either version 3 of the License, or
   % (at your option) any later version.
   %
   % The EHCM Toolbox is distributed in the hope that it will be useful,
   % but WITHOUT ANY WARRANTY; without even the implied warranty of
   % MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   % GNU General Public License for more details.
   %
   % You should have received a copy of the GNU General Public License
   % along with the EHCM Toolbox.  If not, see <http://www.gnu.org/licenses/>.
   %
   % ------------------------------------------------------------------------
   
   
   w = which('EHCMDemoFile.m','-all');
   if numel(w) == 0
      error('Could not find EHCMDemoFile.m. Cannot determine EHCMRootPath');
   elseif numel(w)>1
      warning('Found too many EHCMDemoFile.m. Use the first to determine EHCMRootPath');
      disp(w)
      w = w(1);
   end
   r = fileparts(w{1});
   
end