% ------------------------------------------------------------------------
% This file is part of the EHCM Toolbox v1
%
% The EHCM Toolbox - Energy Hub Component Modeling for Model Predictive Control.
% Copyright (C) 2015  Automatic Control Laboratory, ETH Zurich.
%
% The EHCM Toolbox is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% The EHCM Toolbox is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with the EHCM Toolbox.  If not, see <http://www.gnu.org/licenses/>.
%
% ------------------------------------------------------------------------

function [nodesList,inputList] = nodeListUpdate(nodesList,inputList,tnode)
% check if a new node was added
if ~strcmp(tnode,'')    % node exist
    
    if strncmp(tnode,'u_',2) || strncmp(tnode,'y_',2) % check if node has a prefix
        
        tlen = length(inputList);
        if tlen == 0
            inputList = {tnode};
        else
            flag = 1;
            jj = 1;
            while flag && jj <= tlen
                if strcmp(inputList{jj},tnode)
                    flag = 0;
                end
                jj = jj + 1;
            end
            if flag
                inputList = [inputList; {tnode}];
            end
        end
        
        
    else % it is an EH node
        
        tlen = length(nodesList);
        if tlen == 0
            nodesList = {tnode};
        else
            flag = 1;
            jj = 1;
            while flag && jj <= tlen
                if strcmp(nodesList{jj},tnode)
                    flag = 0;
                end
                jj = jj + 1;
            end
            if flag
                nodesList = [nodesList; {tnode}];
            end
        end
    end
    
end

end