% ------------------------------------------------------------------------
% This file is part of the EHCM Toolbox v1
%
% The EHCM Toolbox - Energy Hub Component Modeling for Model Predictive Control.
% Copyright (C) 2015  Automatic Control Laboratory, ETH Zurich.
%
% The EHCM Toolbox is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% The EHCM Toolbox is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with the EHCM Toolbox.  If not, see <http://www.gnu.org/licenses/>.
%
% ------------------------------------------------------------------------

function x = buildingStates(discSS,x0,u,v,Np)
% x = buildingStates(discSS,x0,u,v)
% to be noted the input vectors...
% Blame for mistakes : Georgios Darivianakis (gdarivia@control.ee.ethz.ch)

%%  Define the extended matrices
nu = size(u,1);
Ae = discSS.ss.A;
Bxue = [];
for ii = 1:nu
    Bxue = [Bxue,discSS.ss.Bxu(:,:,ii)*x0];
end

Bvue = cell(Np,1);
for jj = 1:Np
    Bvue{jj} = [];
    for ii = 1:nu
        Bvue{jj} = [Bvue{jj},discSS.ss.Bvu(:,:,ii)*v.vpred(jj,:)'];
    end
end

Bue = cell(Np,1);
for jj = 1:Np
    Bue{jj} = discSS.ss.Bu + Bxue + Bvue{jj};
end

Bve = discSS.ss.Bv;



x = x0;
for ii = 1:Np
    tmat = ((Ae)^(ii))*x0;
    for jj = 1:ii
        tmat = tmat + ((Ae)^(ii-jj))*Bue{jj}*u(:,jj);
    end
    for jj = 1:ii
        tmat = tmat + ((Ae)^(ii-jj))*Bve*v.vvar(jj,:)';
    end
    x = [x,tmat];
end

end