% ------------------------------------------------------------------------
% This file is part of the EHCM Toolbox v1
%
% The EHCM Toolbox - Energy Hub Component Modeling for Model Predictive Control.
% Copyright (C) 2015  Automatic Control Laboratory, ETH Zurich.
%
% The EHCM Toolbox is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% The EHCM Toolbox is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with the EHCM Toolbox.  If not, see <http://www.gnu.org/licenses/>.
%
% ------------------------------------------------------------------------

function simtime = getDate(MM,DD,HH)

if MM == 1 && DD == 1 && HH == 0
    error('We do not have a prediction vector for the first hour of the year');
end

% we assume that the provided data are correct (e.g. February has 28 days)
cnt = 0;
for ii = 1:MM-1
    if ii == 1
        cnt = cnt + 31*24;
    elseif ii == 2
        cnt = cnt + 28*24;
    elseif ii == 3
        cnt = cnt + 31*24;
    elseif ii == 4
        cnt = cnt + 30*24;
    elseif ii == 5
        cnt = cnt + 31*24;
    elseif ii == 6
        cnt = cnt + 30*24;
    elseif ii == 7
        cnt = cnt + 31*24;
    elseif ii == 8
        cnt = cnt + 31*24;
    elseif ii == 9
        cnt = cnt + 30*24;
    elseif ii == 10
        cnt = cnt + 31*24;
    elseif ii == 11
        cnt = cnt + 30*24;
    end
end
% hours start at zero (check the weather file for conventions)
cnt = cnt + (DD-1)*24 + (HH+1);

simtime = cnt;
end